//+------------------------------------------------------------------+
//|Copy from http://www.forex-tsd.com/metatrader-4/58-trailing-stop-ea.html|
//| |
//+------------------------------------------------------------------+
//#include <stderror.mqh> 
//+------------------------------------------------------------------+
//| Global Variables / Includes                                      |
//+------------------------------------------------------------------+
//extern string Broker5Digits;
extern double             StopLoss                      = 5; // StopLoss
extern double             TrailingStop                  =  1.0; //Trailing Stop
extern double             TakeProfit                    =  100; //Take Profit
extern string iSymbol = ""; 
extern string PreFix = "";
extern string MagicNumber = -1;
//------------------------------------
extern int     TimeOut           = 200;     //-- waiting to check the status of orders (in msec)
extern int     Number_of_Try= 2;       //-- count of attempted closure order
//------------------------------------
double Price_Cls;
string Text;
//+------------------------------------------------------------------+
//| Global Variables / Includes                                      |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
//int deinit() { return(0); }


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

if(Digits == 5 || Digits == 3)
   {
      StopLoss = StopLoss * 10;
      TrailingStop = TrailingStop * 10;
      TakeProfit = TakeProfit * 10;
   }

//----
   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {

//=========================== Set Trading Criterias ==============================

//RefreshRates();

CheckZeroSL ();

ModifySL();
   return(0);
} 
// the end.

double CheckZeroSL (){
int cnt=0;
int tradecnt=0;
double SL = StopLoss*Point; // StopLoss//double SL = StopLoss*Point; // StopLoss
double TS = TrailingStop*Point; //Trailing Stop //double TS = TrailingStop*Point;
double TP = TakeProfit*Point; // TakeProfit //double TP = TakeProfit*Point;
int   i=0;

    for(cnt=0;cnt<OrdersTotal();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
       //(OrderSymbol()     == iSymbol || StringLen(iSymbol) == 0) &&       //-- check symbol
       (OrderSymbol() == Symbol ()) &&  // check for symbol
		 (OrderMagicNumber()== MagicNumber || MagicNumber <= 0) )
         {
         // should it be closed?
          if(OrderStopLoss()==0)
           {
        // check for long position (BUY) possibility
		 // check for ZERO StopLoss 
         if(OrderType()==OP_BUY )   // long position is opened
              {
              OrderModify(OrderTicket(),OrderOpenPrice(),Bid-SL,Ask+TP,0,Yellow);
              return(0); // exit  
              }
         else // go to short position
                {
                 OrderModify(OrderTicket(),OrderOpenPrice(),Ask+SL,Bid-TP,0,Yellow);
                 return(0); // exit  
                }

		      }
       }
    }
}

double ModifySL(){
int cnt=0;
int tradecnt=0;
double SL = StopLoss*Point; // StopLoss//double SL = StopLoss*Point; // StopLoss
double TS = TrailingStop*Point; //Trailing Stop //double TS = TrailingStop*Point;
double TP = TakeProfit*Point; // TakeProfit //double TP = TakeProfit*Point;
int   i=0;

    for(cnt=0;cnt<OrdersTotal();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
       //(OrderSymbol()     == iSymbol || StringLen(iSymbol) == 0) &&       //-- check symbol
       (OrderSymbol() == Symbol ()) &&  // check for symbol
       //(OrderSymbol() == iSymbol || StringLen(iSymbol) == 0) &&  // check for symbol
		 (OrderMagicNumber()== MagicNumber || MagicNumber <= 0) )
         {
         // should it be closed?
         if(OrderType()==OP_BUY )   // long position is opened
           {
        // check for long position (BUY) possibility
             if(OrderStopLoss() >= (Bid+TS))
                return(0); // exit
               {
              if(Bid-OrderOpenPrice()>TS)//if(C-OrderStopLoss()>TS)
                    {
	      	          if(OrderStopLoss()<(Bid-TS))
                        {
                         if(Get_Order_Max() - MarketInfo(OrderSymbol(), MODE_BID)  >= TrailingStop*MarketInfo(OrderSymbol(), MODE_POINT))
                             {
                             Close_Order(OrderTicket());
                             continue;
                             }                         
                        //OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TS,OrderTakeProfit(),0,Yellow);
                        //return(0);
                        }
                    }
                 }

		 }
         else // go to short position
           {
           // check for short position (SELL) possibility
	   		  if(OrderStopLoss() <= (Ask+TS))
      		      return(0); // exit
      		    {
               // check for Long Trailing Stop
                  if((OrderOpenPrice()-Ask)>(TS))//if((OrderStopLoss()-C)>(TS))
                    {
                     if(OrderStopLoss() > (Ask+TS))
                      {
                      if(MarketInfo(OrderSymbol(), MODE_ASK) - Get_Order_Min() >= TrailingStop*MarketInfo(OrderSymbol(), MODE_POINT))
                        {
                        Close_Order(OrderTicket());
                        continue;
                        } 
                     //OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TS,OrderTakeProfit(),0,Yellow);
                      //return(0);
                      }
                    }
			    }
   		  }
		 }
      }
	}

//+------------------------------------------------------------------+
//| returns maximum of the price since order is opened               |
//+------------------------------------------------------------------+
double Get_Order_Max()
{
   double Price;
   int Max_Bar, High_Bar;
      
   Max_Bar = iBarShift(OrderSymbol(), PERIOD_M1, OrderOpenTime());
   High_Bar = iHighest(OrderSymbol(), PERIOD_M1, MODE_HIGH, Max_Bar);
   Price = MathMax(iHigh(OrderSymbol(), PERIOD_M1, High_Bar), OrderOpenPrice());
   
   return(Price);
}

//+------------------------------------------------------------------+
//| returns minimum of the price since order is opened               |
//+------------------------------------------------------------------+
double Get_Order_Min()
{
   double Price;
   int Min_Bar, Low_Bar;
   
   Min_Bar = iBarShift(OrderSymbol(), PERIOD_M1, OrderOpenTime());
   Low_Bar = iLowest(OrderSymbol(), PERIOD_M1, MODE_LOW, Min_Bar);
   Price = MathMin(iLow(OrderSymbol(), PERIOD_M1, Low_Bar), OrderOpenPrice());
   
   return(Price);
}

//+------------------------------------------------------------------+
//| Close order                                                      |
//+------------------------------------------------------------------+
int Close_Order(int Order_ID) 
  {
      int count = Number_of_Try;
//----
      if(!OrderSelect(Order_ID, SELECT_BY_TICKET)) return(0);   
      
      
      int Real_Order = OrderType();  
      double Lot     = OrderLots();
                        
      while(count > 0)                                  //   .
      {       
         count--;
      
         if(!OrderSelect(Order_ID, SELECT_BY_TICKET)) return(0);
         RefreshRates();      
         //--------------------------------------------------------- 7 --
         switch(Real_Order)                        // Order type
         {
            case 0:  Price_Cls=MarketInfo(OrderSymbol(), MODE_BID);          //  Buy
               Text="Buy ";                 //   Buy
               break;                              //  switch
            case 1: Price_Cls=MarketInfo(OrderSymbol(), MODE_ASK);                 //  Sell
               Text="Sell ";                       //   Sell
         }
         double dg=MarketInfo(OrderSymbol(), MODE_DIGITS);
         Print("Attempting to close ",Order_ID,". waiting for reply..","  ",Lot);
         Price_Cls = NormalizeDouble(Price_Cls,MarketInfo(OrderSymbol(), MODE_DIGITS));
         bool Ans  = OrderClose(Order_ID,Lot,Price_Cls, 2);//  
         //--------------------------------------------------------- 8 --
         if (Ans==true)                            //  :)
           {
            Print ("Close order ",Text," ",Order_ID);
            //--    
            break;                                 //    
           }
         //--------------------------------------------------------- 9 --
         int Error=GetLastError();                 //   :(
         switch(Error)                             //  
           {
            case 135:Print("Price changed. Try again ..");
               RefreshRates();                     //  
               continue;                           //  . 
            case 136:Print("No prices. Waiting for a new tick ..");
               while(RefreshRates()==false)        //   
                  Sleep(1);                        //   
               continue;                           //  . 
            case 146:Print("Trading subsystem is busy. Try again ..");
               Sleep(500);                         //  
               RefreshRates();                     //  
               continue;                           //  . 
            case 2 : Print("total mistake.");
               break;                              //   switch
            case 5 : Print("The old version of the client terminal.");
               break;                              //   switch
            case 64: Print("account is blocked.");
               break;                              //   switch
            case 133:Print("Trading is prohibited");
               break;                              //   switch
            default: Print("An error has occurred ",Error);//    
           }
         break;                                    //    
      } 
  
   //----
   return(0);
  }

